/*
 * Renderer 10. The MIT License.
 * Copyright (c) 2022 rlkraft@pnw.edu
 * See LICENSE for details.
*/

import renderer.scene.*;
import renderer.scene.primitives.*;

/**
   This file defines the "basic model" that will be used
   in the example programs.
*/
public class Model_1 extends Model
{
   public Model_1()
   {
      super("Model_1 (basic model)");

      // Create the model's geometry.
      final Vertex v0 = new Vertex( 1.0,  1.0, 0.0);  // a square
      final Vertex v1 = new Vertex(-1.0,  1.0, 0.0);
      final Vertex v2 = new Vertex(-1.0, -1.0, 0.0);
      final Vertex v3 = new Vertex( 1.0, -1.0, 0.0);

      addVertex(v0, v1, v2, v3);
      addPrimitive(new LineSegment(0, 1),
                   new LineSegment(1, 2),
                   new LineSegment(2, 3),
                   new LineSegment(3, 0));

      final Vertex v4 = new Vertex( 2.0,  2.0, 0.0);  // another square
      final Vertex v5 = new Vertex(-2.0,  2.0, 0.0);
      final Vertex v6 = new Vertex(-2.0, -2.0, 0.0);
      final Vertex v7 = new Vertex( 2.0, -2.0, 0.0);

      addVertex(v4, v5, v6, v7);
      addPrimitive(new LineSegment(4, 5),
                   new LineSegment(5, 6),
                   new LineSegment(6, 7),
                   new LineSegment(7, 4));

      // two more line segments
      final Vertex v8 = new Vertex(-2.0,  1.0, 0.0);
      final Vertex v9 = new Vertex( 1.0, -2.0, 0.0);

      addVertex(v8, v9);
      addPrimitive(new LineSegment(0, 4),
                   new LineSegment(8, 9));
   }
}
